<form [formGroup]="form">
  <div class="row">
    <!-- ------------ Naam --------------------------------------- -->
    <div class="form-group col-xs">
      <label for="name">Leerdoel</label>

      <textarea
        type="text"
        rows="2"
        formControlName="name"
        placeholder="De student [actie], waarbij [opties], zodanig dat [concreet doel bereikt wordt]."
        class="form-control"
        [class.is-invalid]="nameControlInvalid"
        required
      ></textarea>
      <div class="invalid-feedback" *ngIf="nameControlInvalid">
        <p>Leerdoel is een verplicht veld.</p>
      </div>
    </div>
  </div>

  <!-- ------------ Korte beschrijving --------------------------- -->
  <div class="row">
    <div class="form-group col-xs">
      <label for="shortDescription">Korte beschrijving</label>
      <input
        type="text"
        formControlName="shortDescription"
        placeholder="Hier een beschrijving"
        class="form-control"
        [class.is-invalid]="shortDescriptionControlInvalid"
      />
      <div class="invalid-feedback" *ngIf="shortDescriptionControlInvalid">
        <p>Een korte beschrijving is verplicht.</p>
      </div>
    </div>
  </div>

  <!-- ------------ Korte beschrijving --------------------------- -->
  <div class="row">
    <div class="form-group col-xs-4">
      <label for="bloomTaxonomy">Bloom niveau</label>
      <select formControlName="bloomTaxonomy" class="form-control" required>
        <option *ngFor="let bloomTaxonomy of bloomTaxonomyLevels" [value]="bloomTaxonomy.name">
          {{ bloomTaxonomy.level }}. {{ bloomTaxonomy.name }}
        </option>
      </select>
      <div class="invalid-feedback" *ngIf="shortDescriptionControlInvalid">
        <p>Een Bloom taxonomie niveau is verplicht.</p>
      </div>
    </div>
    <div class="col-xs-1"></div>
    <div class="form-group col-xs">
      <label>Bloom niveaubeschrijving</label>
      <p>{{ bloomTaxonomyDescription }}</p>
    </div>
  </div>

  <!-- Display Leerlijnen ------------------------------------------ -->
  <div class="row">
    <div class="col-xs-12">
      <h3>Leerlijnen</h3>
      <p>Selecteer de leerlijnen waarvan dit leerdoel onderdeel is.</p>
      <div formArrayName="learningLines">
        <div>
          <ul class="checkbox__list">
            <li class="checkbox__item" *ngFor="let learningLine of learningLines.controls; let i = index">
              <label class="checkbox__item-container">
                {{ learningLine.get('name').value }}
                <input
                  id="checkbox{{ i }}"
                  name="checkbox{{ i }}"
                  type="checkbox"
                  (click)="this.form.markAsDirty()"
                  [formControl]="learningLine.get('selected')"
                />
                <span class="checkmark"></span>
              </label>
            </li>
          </ul>

          <!-- <div *ngFor="let learningLine of learningLines.controls; let i = index">
          <div class="form-group" formGroupName="{{ i }}">
            <input
              id="checkbox{{ i }}"
              name="checkbox{{ i }}"
              type="checkbox"
              (click)="this.form.markAsDirty()"
              [formControl]="learningLine.get('selected')"
              class="custom-control-input"
            />
            <label class="custom-radio-label" for="checkbox{{ i }}">
              {{ learningLine.get('name').value }}
            </label>
          </div> -->
        </div>
      </div>
    </div>
  </div>

  <!-- Display end qualifications ------------------------------------ -->
  <inzicht-endqualification-selector
    [endqualifications]="objective?.endqualifications"
    (update)="onQualificatonsUpdated($event)"
  ></inzicht-endqualification-selector>

  <!-- Display any additional components provided by the calling component. -->
  <ng-content></ng-content>

  <!-- ------------ Administratieve opmerking --------------------------- -->
  <div class="row">
    <div class="form-group col-xs">
      <h3>Administratieve opmerking</h3>
      <textarea
        type="text"
        rows="2"
        class="form-control"
        formControlName="administrativeRemark"
        placeholder="Aantekening of opmerking voor intern gebruik."
        class="form-control"
      ></textarea>
    </div>
  </div>

  <!-- ------------ Buttons -------------------------------------- -->
  <div class="row">
    <div class="col-auto">
      <div class="form-group">
        <button
          type="button"
          class="btn btn-success"
          [disabled]="!form.valid"
          *ngIf="!exists"
          (click)="onCreate(form)"
        >
          Create item
        </button>

        <button
          type="button"
          class="btn btn-success"
          [disabled]="!form.valid || !form.dirty"
          *ngIf="exists"
          (click)="onUpdate(form)"
        >
          Update item
        </button>

        <button type="button" class="btn btn-outline-warning" *ngIf="exists" (click)="onDelete(form)">
          Verwijder item
        </button>

        <button type="button" class="btn btn-spacing btn-outline-warning" (click)="onCancel()">
          Cancel
        </button>
      </div>
    </div>
  </div>
</form>

<div *ngIf="debug">Touched? {{ form.touched | json }} Dirty? {{ form.dirty | json }}</div>

<div *ngIf="debug">
  <pre>{{ form.value | json }}</pre>
</div>
